;*************************************************************************************
;- <<< Operno >>>
; Autor: Josef Sniatecki
; Date: 03.05.2009
; Copyright: Josef Sniatecki 2009 (c)
; 
; Compiler info: standard
;*************************************************************************************




;*******************************************************
;- < Intergrations >
;
;*******************************************************

IncludeFile "Operno.pbi"
InitOperno()



;*******************************************************
;- < Structures >
;
;*******************************************************

Structure Square
  Width.i
  Height.i
  X.i
  Y.i
  MoveX.i
  MoveY.i
  Color.i
  *Item
EndStructure




;*******************************************************
;- < Variables >
;
;*******************************************************

Global NewList *Square.Square()

Global *BackgroundColor=OpernoCreateIVariable("backColor",$000000,*OpernoMainObject)
Global *ScreenWidth    =OpernoCreateIVariable("screenWidth",1024,*OpernoMainObject)
Global *ScreenHeight   =OpernoCreateIVariable("screenHeight",768,*OpernoMainObject)
Global *ScreenDepth    =OpernoCreateIVariable("screenDepth",32,*OpernoMainObject)
Global *SquareClass    =OpernoCreateGroup("square",*OpernoMainObject) ;Leere Klasse erstellen.

Global *LoopCallback
Global *DrawCallback

Global SourceFilename.s



;*******************************************************
;- < Square-class >
;
;*******************************************************

Procedure.i Main_Square_BumpOnBorders()
  Protected *Table.Square,X.f,Y.f,Width.i,Height.i
  
  *Table=OpernoTable()
  With *Table
    ; Werte fr einen schnellen Zugriff auslesen.
    X     =OpernoVariableF(*Table\X)
    Y     =OpernoVariableF(*Table\Y)
    Width =OpernoVariableI(*Table\Width)
    Height=OpernoVariableI(*Table\Height)
    If X<0
      ; Kollision am rechten Rand:
      OpernoSetFVariable(*Table\X,0)
      OpernoSetFVariable(*Table\MoveX,-OpernoVariableF(*Table\MoveX))
    ElseIf X+Width>OpernoVariableI(*ScreenWidth)
      ; Kollision am linken Rand:
      OpernoSetFVariable(*Table\X,OpernoVariableI(*ScreenWidth)-Width)
      OpernoSetFVariable(*Table\MoveX,-OpernoVariableF(*Table\MoveX))
    EndIf
    If Y<0
      ; Kollision am oberen Rand:
      OpernoSetFVariable(*Table\Y,0)
      OpernoSetFVariable(*Table\MoveY,-OpernoVariableF(*Table\MoveY))
    ElseIf Y+Height>OpernoVariableI(*ScreenHeight)
      ; Kollision am unteren Rand:
      OpernoSetFVariable(*Table\Y,OpernoVariableI(*ScreenHeight)-Height)
      OpernoSetFVariable(*Table\MoveY,-OpernoVariableF(*Table\MoveY))
    EndIf
  EndWith
EndProcedure
Procedure.i Main_Square_Locate()
  Protected *Table.Square
  
  *Table=OpernoTable()
  With *Table
    OpernoPopVariable(*Table\X)
    OpernoPopVariable(*Table\Y)
  EndWith
EndProcedure
Procedure.i Main_Square_Move()
  Protected *Table.Square,X.f,Y.f
  
  *Table=OpernoTable()
  With *Table
    OpernoPopFValue(@X)
    OpernoPopFValue(@Y)
    OpernoSetFVariable(*Table\MoveX,OpernoVariableF(*Table\MoveX)+X)
    OpernoSetFVariable(*Table\MoveY,OpernoVariableF(*Table\MoveY)+Y)
  EndWith
EndProcedure
Procedure.i Main_Square_Stop()
  Protected *Table.Square
  
  *Table=OpernoTable()
  With *Table
    OpernoSetFVariable(*Table\MoveX,0)
    OpernoSetFVariable(*Table\MoveY,0)
  EndWith
EndProcedure
Procedure.i Main_Square_CM_New()
  Protected *This.OpernoValue,*Memory,*Table.Square
  
  ; Memory ist das Objekt, auf welches durch Operno zugegriffen werden kann.
  ; An dieses Objekt ist ein Block von eigenen Daten angehngt, welches durch
  ; "OpernoGetVirtualTable" ermittelt werden kann.
  *Memory=OpernoCreateVirtualTable(SizeOf(Square))
  ; Die Variable durch "OpernoThis" ermitteln:
  *This=OpernoThis()
  ; Scopes und andere Daten setzen:
  *This\Scope|#OpernoValue_Searchable
  *This\Memory=*Memory
  
  ; Die Adresse des Tables in die Liste spiechern:
  AddElement(*Square())
  *Table=OpernoGetVirtualTable(*Memory)
  *Square()=*Table
  
  ; Instanz-Variablen erstellen:
  With *Table
    \Width =OpernoCreateIVariable("width",0,*Memory)
    \Height=OpernoCreateIVariable("height",0,*Memory)
    \X     =OpernoCreateFVariable("x",0,*Memory)
    \Y     =OpernoCreateFVariable("y",0,*Memory)
    \MoveX =OpernoCreateFVariable("moveX",0,*Memory)
    \MoveY =OpernoCreateFVariable("moveY",0,*Memory)
    \Color =OpernoCreateIVariable("color",0,*Memory)
    ; Ein Verweis auf das aktuelle Element setzen:
    \Item  =@*Square()
  EndWith
EndProcedure
Procedure.i Main_Square_CM_Def()
  Protected *Table.Square
  
  *Table=OpernoTable()
  With *Table
    ; Werte der Instanz-Variablen durch Parameter ermitteln:
    OpernoPopVariable(*Table\Width)
    OpernoPopVariable(*Table\Height)
    OpernoPopVariable(*Table\X)
    OpernoPopVariable(*Table\Y)
    OpernoPopVariable(*Table\Color)
  EndWith
EndProcedure
Procedure.i Main_Square_CM_Del()
  Protected *Table.Square
  
  *Table=OpernoTable()
  With *Table
    ; Das jeweilige Element der Liste zerstren:
    ChangeCurrentElement(*Square(),*Table\Item)
    DeleteElement(*Square())
  EndWith
EndProcedure
Procedure.i Main_Square_CM_Form()
  Protected *Table.Square
  
  *Table=OpernoTable()
  With *Table
    ProcedureReturn OpernoPushSValue("square("+StrF(OpernoVariableF(\X))+", "+StrF(OpernoVariableF(\Y))+")")
  EndWith
EndProcedure

; Objekte fr die Square-Klasse:
DataSection
  SquareClass:
    Data.c #OpernoObject_Function : Data.s "bumpOnBorders" ;{
      Data.i @Main_Square_BumpOnBorders()
    ;}
    Data.c #OpernoObject_Function : Data.s "locate" ;{
      Data.i @Main_Square_Locate()
    ;}
    Data.c #OpernoObject_Function : Data.s "move" ;{
      Data.i @Main_Square_Move()
    ;}
    Data.c #OpernoObject_Function : Data.s "stop" ;{
      Data.i @Main_Square_Stop()
    ;}
    Data.c #OpernoObject_Function : Data.s "_new" ;{
      Data.i @Main_Square_CM_New()
    ;}
    Data.c #OpernoObject_Function : Data.s "_def" ;{
      Data.i @Main_Square_CM_Def()
    ;}
    Data.c #OpernoObject_Function : Data.s "_del" ;{
      Data.i @Main_Square_CM_Del()
    ;}
    Data.c #OpernoObject_Function : Data.s "_form" ;{
      Data.i @Main_Square_CM_Form()
    ;}
    Data.c #Null
EndDataSection
; Diese Objekte in Operno einbinden, damit ein Zugriff ber ein
; Skript mglich ist:
OpernoExtractObject(*SquareClass,?SquareClass)



;*******************************************************
;- < Misc functions >
;
;*******************************************************

Procedure.i Main_DrawText()
  Protected X.i,Y.i,Text.String,Color.i
  
  Text\S=""
  Color=$FFFFFF
  
  OpernoPopIValue(@X)
  OpernoPopIValue(@Y)
  OpernoPopSValue(@Text)
  OpernoPopIValue(@Color)
  
  DrawingMode(#PB_2DDrawing_Transparent)
  DrawText(X,Y,Text\S,Color)
EndProcedure
Procedure.i Main_DrawLine()
  Protected X.i,Y.i,ToX.i,ToY.i,Color.i
  
  Color=$FFFFFF
  
  OpernoPopIValue(@X)
  OpernoPopIValue(@Y)
  OpernoPopIValue(@ToX)
  OpernoPopIValue(@ToY)
  OpernoPopIValue(@Color)
  
  DrawingMode(#PB_2DDrawing_Default)
  LineXY(X,Y,ToX,ToY,Color)
EndProcedure

DataSection
  MiscFunctions:
    Data.c #OpernoObject_Function : Data.s "drawText" ;{
      Data.i @Main_DrawText()
    ;}
    Data.c #OpernoObject_Function : Data.s "drawLine" ;{
      Data.i @Main_DrawLine()
    ;}
    Data.c #Null
EndDataSection
OpernoExtractObject(*OpernoMainObject,?MiscFunctions)



;*******************************************************
;- < Procedures >
;
;*******************************************************

Procedure.i OptimizeCPU(StandardTime.i=16)
  Static Time.i
  Protected Difference.i,CurrentTime.i
  
  If Time
    CurrentTime=ElapsedMilliseconds()
    Difference=CurrentTime-Time
    Time=CurrentTime
  Else
    Time=ElapsedMilliseconds()
    Difference=0
  EndIf
  If Difference<StandardTime
    Delay(StandardTime-Difference)
  EndIf
EndProcedure

;*******************************************************
;- < Main >
;
;*******************************************************

; Eine Datei in Operno aussuchen, die Ausgefhrt werden soll. Beispiel-Quelltexte
; befinden sich im Ordner "Operno\Examples\german\Squares".
If ProgramParameter(0)
  SourceFilename=ProgramParameter(0)
Else
  SourceFilename=OpenFileRequester("Source file","Examples\german\Squares\","*.*",0)
EndIf
If SourceFilename
  OpernoExecuteFile(SourceFilename)
  If OpernoError()
    MessageRequester("Error",OpernoErrorMessage(),#MB_ICONERROR)
    End
  EndIf
Else
  End
EndIf



; Die Callback-Funktion namens "loop" ermitteln. Dadurch hat man
; spter einen schnelleren Zugriff. Ebenso wird "draw" ermittelt.
*LoopCallback=OpernoFindObject(*OpernoMainObject,"loop")
*DrawCallback=OpernoFindObject(*OpernoMainObject,"draw")



InitSprite()
InitKeyboard()
OpenScreen(OpernoVariableI(*ScreenWidth),OpernoVariableI(*ScreenHeight),OpernoVariableI(*ScreenDepth),"Squares")



; Und hier fngt das Eigentliche an:
Repeat
  ExamineKeyboard()
  
  ClearScreen(OpernoVariableI(*BackgroundColor))
    StartDrawing(ScreenOutput())
      ; Alle Rechtecke zeichnen lassen:
      DrawingMode(#PB_2DDrawing_Default)
      With *Square()
        ForEach *Square()
          Box(OpernoVariableF(\X),OpernoVariableF(\Y),OpernoVariableI(\Width),OpernoVariableI(\Height),OpernoVariableI(\Color))
        Next
      EndWith
      ; Das Callback fr's Zeichnen aufrufen:
      If *DrawCallback
        OpernoCall(*DrawCallback)
      EndIf
    StopDrawing()
  FlipBuffers()
  
  ; Alle Rechtecke bewegen:
  With *Square()
    ForEach *Square()
      OpernoSetFVariable(\X,OpernoVariableF(\X)+OpernoVariableF(\MoveX))
      OpernoSetFVariable(\Y,OpernoVariableF(\Y)+OpernoVariableF(\MoveY))
    Next
  EndWith
  
  ; Das Callback mit dem Namen "loop" aufrufen:
  If *LoopCallback
    OpernoCall(*LoopCallback)
  EndIf
  ; Die CPU nicht auslasten:
  OptimizeCPU()
Until KeyboardPushed(#PB_Key_Escape) Or OpernoError()



CloseScreen()
If OpernoError()
  MessageRequester("Error",OpernoErrorMessage(),#MB_ICONERROR)
EndIf
End
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 303
; FirstLine = 282
; Folding = ----
; EnableXP
; Executable = Squares.exe